#====================================================================#
#   SCRIPT:        Change_Alarm_Datacenter.ps1                       #
#   FUNCTION:      Modify multiple Alarm definitions in vCenter      #
#   CREATED:       10/06/2011                                        #
#   VERSION:       v.1.1                                             #
#====================================================================#
#   CHANGELOG:                                                       #
#                                                                    #
#    v.1.1                                                           #
#    - Deleted email body                                            #
#    - Added Alarm definition                                        #
#    - Added changelog                                               #
#                                                                    #
#    v.1.0                                                           #
#    - First Release                                                 #
#                                                                    #
#====================================================================#
# Note: You only have to change the "MailToRandom1" value in "Custom #
#         Definitions" to change the alarm action                    #
#====================================================================#
# Connect vCenter server;
#--------------------------------------------------------------------#
$vCenterServer = "192.168.126.10"
$user = "VCENTER USER NAME"
$pass = "VCENTER PASSWORD"
 

  Connect-VIServer -Server $vCenterServer -Protocol https -User $user -Password $pass -WarningAction SilentlyContinue | Out-Null

 
#--------------------------------------------------------------------#
# Custom Definitions;
#--------------------------------------------------------------------#
$actType = "SendEmailAction"
$MailToRandom1 = "EMAIL ADDRESS 1"
$MailToDefault1 = "EMAIL ADDRESS 2"
$MailToDefault2 = "EMAIL ADDRESS 3"



#--------------------------------------------------------------------#
# Alarms to Set;
#--------------------------------------------------------------------#
$actAlarm1 = "Cluster high availability error"
$actAlarm2 = "Cannot connect to storage"
$actAlarm3 = "Datastore usage on disk"
$actAlarm4 = "Host connection and power state"
$actAlarm5 = "Host connection failure"
$actAlarm6 = "Host cpu usage"
$actAlarm7 = "Host hardware fan status"
$actAlarm8 = "Host hardware power status"
$actAlarm9 = "Host hardware system board status"
$actAlarm10 = "Host hardware temperature status"
$actAlarm11 = "Host memory usage"
$actAlarm12 = "Host storage status"
$actAlarm13 = "Network connectivity lost"
$actAlarm14 = "Network uplink redundancy degraded"
$actAlarm15 = "Network uplink redundancy lost"
$actAlarm16 = "Virtual machine cpu usage"
$actAlarm17 = "Virtual machine error"


$actSubject = "Get-AlarmDefinition"
#--------------------------------------------------------------------#
# Delete Alarm Trigger;
#--------------------------------------------------------------------#
Get-AlarmDefinition -Name "$actAlarm1" , "$actAlarm2" , "$actAlarm3", "$actAlarm4", "$actAlarm5", "$actAlarm6", "$actAlarm7", "$actAlarm8", "$actAlarm9", "$actAlarm10", "$actAlarm11", "$actAlarm12", "$actAlarm13", "$actAlarm14", "$actAlarm15", "$actAlarm16", "$actAlarm17" | Get-AlarmAction | Remove-AlarmAction -Confirm:$false
#--------------------------------------------------------------------#
# Create Alarm Trigger;
#--------------------------------------------------------------------#
Get-AlarmDefinition -Name "$actAlarm1" , "$actAlarm2" , "$actAlarm3", "$actAlarm4", "$actAlarm5", "$actAlarm6", "$actAlarm7", "$actAlarm8", "$actAlarm9", "$actAlarm10", "$actAlarm11", "$actAlarm12", "$actAlarm13", "$actAlarm14", "$actAlarm15", "$actAlarm16", "$actAlarm17" | New-AlarmAction -Email -To "$MailToRandom1" , "$MailToDefault1" , "$MailToDefault2"
Get-AlarmDefinition -Name "$actAlarm1" , "$actAlarm2" , "$actAlarm3", "$actAlarm4", "$actAlarm5", "$actAlarm6", "$actAlarm7", "$actAlarm8", "$actAlarm9", "$actAlarm10", "$actAlarm11", "$actAlarm12", "$actAlarm13", "$actAlarm14", "$actAlarm15", "$actAlarm16", "$actAlarm17" | Get-AlarmAction | New-AlarmActionTrigger -StartStatus "Green" -EndStatus "Yellow"
#--------------------------------------------------------------------#
# Disconnect vCenter server;
#--------------------------------------------------------------------#
Disconnect-VIServer -Server $vCenterServer -Force:$true -Confirm:$false
#--------------------------------------------------------------------#